import java.util.*;
import java.lang.*;
import java.lang.reflect.*;
import java.net.*;
import java.text.*;
import javax.swing.*;

public class Query extends Thread
{
		private String srv;
		private JTextArea ta;
		private boolean debug;
		private int timeout;

    public Query (String q_srv, JTextArea q_ta, boolean q_debug, int q_timeout)
		{
			srv = q_srv;
			ta = q_ta;
			debug = q_debug;
			timeout = q_timeout;
		}

    public void run()
    {
    		// <ntp-stable/include/ntp_unixtime.h>
		    long JAN_1970 = 2208988800L;

        DatagramSocket s;
        DatagramPacket xpkt, rpkt;
        byte[] data;
        long crecv = 0;
        long rorig = 0, ct = 0, ct_s = 0, ct_f = 0;
        String ans = "";

        data = new byte[72];
        data[0] = -29;	// bin: 11100001 :)))
        try {
            s = new DatagramSocket();
						s.setSoTimeout(timeout);
            // s.setTrafficClass(0x10);
						if (debug) ta.append(".");
            InetAddress ia = InetAddress.getByName(srv);
						if (debug) ta.append(".");
            rpkt = new DatagramPacket(data, 72);
						if (debug) ta.append(".");
            xpkt = new DatagramPacket(data, 48, ia, 123);
						if (debug) ta.append(".");

            ct = System.currentTimeMillis();
						if (debug) ta.append(".");
            ct_s = ct/1000 + JAN_1970;
            ct_f = (ct - (ct/1000)*1000) * 4294967; // 0xffffffff/1000;;

            data[40] = (byte) ((ct_s >> 24) & 0xff);
            data[41] = (byte) ((ct_s >> 16) & 0xff);
            data[42] = (byte) ((ct_s >>  8) & 0xff);
            data[43] = (byte) (ct_s & 0xff);

            data[44] = (byte) ((ct_f >> 24) & 0xff);
            data[45] = (byte) ((ct_f >> 16) & 0xff);
            data[46] = (byte) ((ct_f >>  8) & 0xff);
            data[47] = (byte) (ct_f & 0xff);

            // rorig = System.currentTimeMillis();
            s.send(xpkt);
						if (debug) ta.append(".");
            s.receive(rpkt);
						if (debug) ta.append(".");
            crecv = System.currentTimeMillis();
						if (debug) ta.append(".");

            xpkt = rpkt = null;
        } catch (Exception e) {
            ans += e.toString();
            ta.append("server " + srv + ":" + ans + "\n");
            return;
        }

        int stratum = Array.getByte(data, 1);
        int base;

        /* Reference Timestamp */
        long ref = 0;
        base = 16;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            ref += ub << ((3-i)*8);
        }
        ref -= JAN_1970;
        ref *= 1e3;

        long ref_f = 0;
        base += 4;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            ref_f += ub << ((3-i)*8);
        }
        ref += (1e3*ref_f)/0xffffffffL;

        /* Originate TimeStamp */
        long orig = 0;
        base = 24;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            orig += ub << ((3-i)*8);
        }
        if (orig != ct_s) {
            ans += "\norig != ct_s\n";
            ta.append("server " + srv + ":" + ans + "\n");
            return;
        }
        orig -= JAN_1970;
        orig *= 1e3;

        long orig_f = 0;
        base += 4;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            orig_f += ub << ((3-i)*8);
        }
        if (orig_f != ct_f) {
            ans += "\norig_f != ct_f\n";
            ta.append("server " + srv + ":" + ans + "\n");
            return;
        }
        orig += (1e3*orig_f)/0xffffffffL;

        /* Receive TimeStamp */
        long recv = 0;
        base = 32;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            recv += ub << ((3-i)*8);
        }
        recv -= JAN_1970;
        recv *= 1e3;

        long recv_f = 0;
        base += 4;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            recv_f += ub << ((3-i)*8);
        }
        recv += (1e3*recv_f)/0xffffffffL;

        /* Transmit TimeStamp */
        long xmt = 0;
        base = 40;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            xmt += ub << ((3-i)*8);
        }
        xmt -= JAN_1970;
        xmt *= 1e3;

        long xmt_f = 0;
        base += 4;
        for(int i = 0; i < 4; i++) {
            byte b = data[base+i];
            long ub = (b >= 0) ? b : 256 + b;
            xmt_f += ub << ((3-i)*8);
        }
        xmt += (1e3*xmt_f)/0xffffffffL;

        ans += "server " + srv;
        ans +=", stratum " + stratum;

        /*
        String leap = "";
        switch ((Array.getByte(data, 0) >> 6) & 0x03)
        {
        	case 0: leap = "no warning";
        		break;
        	case 1: leap = "last minute has 61 seconds";
        		break;
        	case 2: leap = "last minute has 59 seconds";
        		break;
        	case 3: leap = "alarm condition (clock not synchronized)";
        		break;
        };
               System.out.print (", leap = " + leap);
        /*

        // System.out.println ("version number = " + ((Array.getByte(data, 0) >> 3) & 0x07));
        // System.out.println ("poll = " + Array.getByte(data, 2));
        // System.out.println ("precision = " + ((Array.getByte(data, 0) >> 3) & 0x07));

        /*
        DateFormat df = DateFormat.getDateTimeInstance(DateFormat.FULL, DateFormat.FULL);
               Date now = new Date();

        now.setTime(ref);
               System.out.println ("reference=" + df.format(now));
        now.setTime(orig);
               System.out.println ("originate=" + df.format(now));
        now.setTime(recv);
               System.out.println ("receive=" + df.format(now));
        now.setTime(xmt);
               System.out.println ("transmit=" + df.format(now));

        now.setTime(crecv);
               System.out.println ("crecv=" + df.format(now));
        */

        // orig = rorig;

        long delay = (crecv - orig) - (xmt - recv);
        long offset = ((recv - orig) + (xmt - crecv))/2;

        ans += ", offset " + offset + "[ms]";
        ans += ", delay " + delay + "[ms]";
        ans += "\n";

        /*
               System.out.println ("ref =" + ref);
               System.out.println ("ct  =" + ct);
               System.out.println ("orig=" + orig);
               System.out.println ("recv=" + recv);
               System.out.println ("xmt =" + xmt);
               System.out.println ("crec=" + crecv);
        */
        ta.append(ans);
        return;
    }
};
